//!
//! @file $RCSfile: classB.c,v $
//!
//! Copyright (c) 2006 Atmel.
//!
//! @brief {IEC60730׽B@\ƎI񋟂܂B
//! @version $Revision: 1.5 $
//!

//_____  ݸٰ ______________________________________________________________
#include "ioavr.h"
#include "inavr.h"

#include "classb.h"
#include <classB_config.h>

//_____ ϸ ___________________________________________________________________

//_____ ` __________________________________________________________________

#define WDT_TIMER	0x18

// ʖ߂l
#define TEST_OK		1
#define TEST_FAIL	0

//_____ 錾 __________________________________________________________________

__no_init unsigned char LastResetReason;
unsigned char Interrupt_Test_Flag;

/**
 * @brief 荞ݐ팟
 *		  pɂĎgpȂ荞݂gp
 * @pre p荞݌`Ԑݒ()
 * @post Interrupt_Test_Flagݒ
 */
#pragma vector = TIMER0_OVF_vect
__interrupt void unused_interrupt(void)
{
	Interrupt_Test_Flag = 1;
}

//! @brief ŌؾėRALastResetReasonϐɕۑ\n
//!
void Find_Reset_Reason(void)
{
	unsigned char i, mask;
	// Find Reset Reason
	mask = 0x01;
	for ( i=0;i<5;i++ )
	{
		if ( MCUCSR & mask )
		{
			break;
		}
		mask = mask << 1;
	}
	LastResetReason = i;					// ؾėR`p(classB.hQ)
}

//! @brief ̊֐̖ړIͳޯ ؾĂ邱ƂłB\n
//!		   ޲ޯޗvؾĂ̂mɂ邽߁A\n
//!		   dųޯނɂؾĂN̂҂܂B\n
//!		   ޯ ؾĂŊ֐TRUEԂ܂B\n
//!
//! @return (TEST_FAIL܂TEST_OK)
//!
static unsigned char watchdog_test(void)
{
	unsigned char result = TEST_FAIL;
	if ( !(LastResetReason & RESET_WAITING) )	// Ӑ}ؾ
	{
		Find_Reset_Reason();				// ؾėRLast_Reset_ReasonϐɊi[
	}
	if( (MCUCSR & 0x08) == 0x08)			// ޯ ؾĔŁA
	{
		result = TEST_OK;
	}
	else									// (WDTłȂ)ؾĔŁAޯފJn
	{
		MCUCSR = 0;							// MCU/ڼ޽(ؾČ׸މ)
		WDTCR |= (1<<WDTOE | 1<<WDE);		// ޯޕύX
		WDTCR =  WDT_TIMER;					// ޯޑsJn
		LastResetReason |= RESET_WAITING;
		while(1);							// ؾđҋ@
	}
	LastResetReason = LastResetReason & (RESET_WAITING ^ 0xFF);
	MCUCSR = 0;								// MCU/ڼ޽(ؾČ׸މ)
	return result;
}

//! @brief ̊֐̖ړICPUð ڼ޽邱ƂłB\n
//!		   :S̊荞݋(I)ޯĂ͂Ō܂B\n
//!
//! @return cpu_status_result ð ڼ޽̕sޯĂɑΉĐݒ肳ޯĂ8ޯĒl(Q)\n
//! return value = 0	OK \n
//! return value = 0x02	ޯ1(Z)~ \n
//!
static unsigned char cpu_status_test(void)
{
	unsigned char a,sav_sreg,cpu_status_result=0;

	/* ð ڼ޽ */
	sav_sreg = SREG;
	SREG = 0x55;
	a=SREG;
	SREG=sav_sreg;
	if (a != 0x55)
	{
		cpu_status_result=TEST_FAIL;
	}
	else
	{
		sav_sreg = SREG;
		SREG = 0x2A;						// S̊荞݋(I)ޯĂ͊荞݌Ō܂B
		a=SREG;
		SREG=sav_sreg;
		if (a == 0x2A)
		{
			cpu_status_result=TEST_OK;
		}
		else
		{
			cpu_status_result=TEST_FAIL;
		}
	}
	return cpu_status_result;
}

//! @brief ̊֐̖ړI͓SRAM邱ƂłB
//!		   SRAMޯĂȂƂȂ邽߂0x550xAAŖ܂B
//!		   siB͗̈Ԃł̏d2̗̈Ŏs܂B
//! \n return value = 0		OK
//! \n return value != 0	~
//! sׂ:SRAMlۑ邽߂̂̺ނǉ
static unsigned char sram_test(void)
{
	register unsigned char *p_val,*p_sav,i,sav;
	register unsigned char val;
	register signed  char h; 

	/* 0x55A0xAAAڽl̕␔őSʒu */
	for (p_val=(unsigned char *)SRAM_START_ADR;p_val<((unsigned char *)(SRAM_START_ADR+SRAM_SIZE));p_val++)
	{
		sav = *p_val;
		*p_val = 0x55;
		i = *p_val;
		if (i!=0x55) { return TEST_FAIL; }
		*p_val = 0xAA;
		i = *p_val;
		if (i!=0xAA) { return TEST_FAIL; }
		val = ~((unsigned char)p_val);
		*p_val = val;
		i = *p_val;
		if (i != val) { return TEST_FAIL; }
		*p_val=sav;
	}

	/* 1 */ 
	/* SSRAM */
	for (p_val=(unsigned char *)(SRAM_START_ADR+SRAM_SIZE);p_val>=((unsigned char *)SRAM_START_PAGE2);p_val--)
	{
		*p_val=0;
	}

	/* 2 */
	for (p_val=(unsigned char *)SRAM_START_PAGE2;p_val<((unsigned char *)(SRAM_START_ADR+SRAM_SIZE));p_val++)
	{
		for (h=0;h<8;h++)
		{
			val =(((*p_val)>>h) & 0x01);	// 0ǂݍ
			if (val!= 0x00)
			{
				return TEST_FAIL;
			}

			val = *p_val | (1<<h);
			*p_val= val;					// 1

			val =(((*p_val)>>h) & 0x01);	// 1ǂݍ
			if (val!= 0x01)
			{
				return TEST_FAIL;
			}

			val =  *p_val  & ~(1<<h);
			*p_val= val;					// 0

			val =(((*p_val)>>h) & 0x01);	// 0ǂݍ
			if (val!= 0x00)
			{
				return TEST_FAIL;
			}

			*p_val=(*p_val | (1<<h));		// 1
		}
	}

	/* 3 */
	for (p_val=(unsigned char *)SRAM_START_PAGE2;p_val<((unsigned char *)(SRAM_START_ADR+SRAM_SIZE));p_val++)
	{
		for (h=0;h<8;h++)
		{

			val =(((*p_val)>>h) & 0x01);	// 1ǂݍ
			if (val!= 0x01)
			{
				return TEST_FAIL;
			}

			val =  *p_val  & ~(1<<h);
			*p_val= val;					// 0

			*p_val=(*p_val | (1<<h));		// 1

		}
	}

	/* 4 */
	for (p_val=(unsigned char *)(SRAM_START_ADR+SRAM_SIZE-1);p_val>=((unsigned char *)SRAM_START_PAGE2);p_val--) 
	{
		for (h=7;h>=0;h--)
		{

			val =(((*p_val)>>h) & 0x01);	// 1ǂݍ
			if (val!= 0x01)
			{
				return TEST_FAIL;
			}

			val =  *p_val & ~(1<<h);
			*p_val= val;					// 0

			*p_val=(*p_val | (1<<h));		// 1

			val =  *p_val & ~(1<<h);
			*p_val= val;					// 0

		}
	}

	/* 5 */
	for (p_val=(unsigned char *)(SRAM_START_ADR+SRAM_SIZE-1);p_val>=((unsigned char *)SRAM_START_PAGE2);p_val--)  
	{
		for (h=7;h>=0;h--)
		{

			val =(((*p_val)>>h) & 0x01);	// 0ǂݍ
			if (val!= 0x00)
			{
				return TEST_FAIL;
			}

			*p_val=(*p_val | (1<<h));		// 1

			val =  *p_val & ~(1<<h);
			*p_val= val;					// 0

		}
	}

	/* SRAM_START_ADR`SRAM_START_PAGE2̗̈Ō */
	/* SRAM̐擪SRAM_START_ADR`SRAM_START_PAGE2̗̈ۑ */
	p_sav = (unsigned char *)SRAM_END_ADR;
	for (p_val = ((unsigned char *)SRAM_START_ADR); \
		 p_val <= (unsigned char *)(SRAM_START_PAGE2-1); \
		 p_val ++)
	{
		*(p_sav--) = *(p_val) ;
	}

	/*  ߲ۑ */
	*(p_sav--)=SPH;
	*(p_sav--)=SPL;
	/* ͐V ߲gp */
	SP = (unsigned int)p_sav;

	/* 1 - 2̈ */
	for (p_val=(unsigned char *)(SRAM_START_PAGE2+15);p_val>=((unsigned char *)SRAM_START_ADR);p_val--)
	{
		*p_val=0;
	}

	/* 2 - 2̈ */
	for (p_val=(unsigned char *)SRAM_START_ADR;p_val<((unsigned char *)(SRAM_START_PAGE2+15));p_val++)
	{
		for (h=0;h<8;h++)
		{
			val =(((*p_val)>>h) & 0x01);	// 0ǂݍ
			if (val!= 0x00)
			{
				return TEST_FAIL;
			}

			val = *p_val | (1<<h);
			*p_val= val;					// 1

			val =(((*p_val)>>h) & 0x01);	// 1ǂݍ
			if (val!= 0x01) 
			{
				return TEST_FAIL;
			}

			val =  *p_val  & ~(1<<h);
			*p_val= val;					// 0

			val =(((*p_val)>>h) & 0x01);	// 0ǂݍ
			if (val!= 0x00) 
			{
				return TEST_FAIL;
			}

			*p_val=(*p_val | (1<<h));		// 1
		}
	}

	/* test 3 - 2̈ */
	for (p_val=(unsigned char *)SRAM_START_ADR;p_val<((unsigned char *)(SRAM_START_PAGE2+15));p_val++)
	{
		for (h=0;h<8;h++)
		{

			val =(((*p_val)>>h) & 0x01);	// 1ǂݍ
			if (val!= 0x01)
			{
				return TEST_FAIL;
			}

			val =  *p_val  & ~(1<<h);
			*p_val= val;					// 0

			*p_val=(*p_val | (1<<h));		// 1

		}
	}

	/* test 4 - 2̈ */ 
	for (p_val=(unsigned char *)(SRAM_START_PAGE2+14);p_val>=((unsigned char *)SRAM_START_ADR);p_val--)
	{
		for (h=7;h>=0;h--)
		{

			val =(((*p_val)>>h) & 0x01);	// 1ǂݍ
			if (val!= 0x01)
			{
				return TEST_FAIL;
			}

			val =  *p_val & ~(1<<h);
			*p_val= val;					// 0

			*p_val=(*p_val | (1<<h));		// 1

			val =  *p_val & ~(1<<h);
			*p_val= val;					// 0

		}
	}

	/* test 5 - 2̈ */
	for (p_val=(unsigned char *)(SRAM_START_PAGE2+14);p_val>=((unsigned char *)SRAM_START_ADR);p_val--)
	{
		for (h=7;h>=0;h--)
		{

			val =(((*p_val)>>h) & 0x01);	// 0ǂݍ
			if (val!= 0x00) 
			{
				return TEST_FAIL;
			}

			*p_val=(*p_val | (1<<h));		// 1

			val =  *p_val & ~(1<<h);
			*p_val= val;					// 0

		}
	}

	/* SRAM擪SRAM_START_AD`SRAM_START_PAGE2̈𕜌 */
	p_sav = (unsigned char *)SRAM_END_ADR;
	for (p_val = ((unsigned char *)SRAM_START_ADR); \
		 p_val <= (unsigned char *)(SRAM_START_PAGE2-1); \
		 p_val ++)
	{
		*(p_val) = *(p_sav--) ;
	}
	/*  ߲𕜌 */
	sav = *(p_sav--);
	i = *(p_sav--);
	SP = (sav<<8) + i;

  return TEST_OK;
}

//! @brief ̊֐̖ړI/0Ƃ̊荞ݏo͂邱ƂłB
//!		   ̊֐8ޯĒlԂ܂B
//! return value = TEST_OK܂TEST_FAIL
static unsigned char timer0_test(void)
{
	register unsigned char i,t,val,u;

	TIMSK = 0x55;
	if (TIMSK != 0x55) return TEST_FAIL;
	TIMSK = 0xAA;
	if (TIMSK != 0xAA) return TEST_FAIL;
	TIMSK = 0;

	OCR0 = 0x55;
	if (OCR0 != 0x55) return TEST_FAIL;
	OCR0 = 0xAA;
	if (OCR0 != 0xAA) return TEST_FAIL;
	OCR0 = 0;

	TCNT0 = 0x55;
	if (TCNT0 != 0x55) return TEST_FAIL;
	TCNT0 = 0xAA;
	if (TCNT0 != 0xAA) return TEST_FAIL;

	TCCR0 = 0x55;
	if (TCCR0!= 0x55) return TEST_FAIL;
	TCCR0 = 0xAA;
	if (TCCR0 != 0x2A) return TEST_FAIL;

	/* /0荞ݐM */
	TCNT0 = 150;
	OCR0 = 200;
	TCCR0 = 1;								// /0n

	i=0;
	t=0;
	if ((TIFR & 0x03)!=0) return TEST_FAIL;
	while (i < 200)							// Ԓߋ@\
	{
		val = (TIFR & 0x03);
		u = ((t<<4)+val);					// ԂTIFRl
		switch (u)
		{
			case 0x00:						// Ԃɗ܂
				break;
			case 0x02:						// OCF0
				t = 2;						// 2
				break;
			case 0x22:						// 2ɗ܂
				break;
			case 0x23:						// TOV0AOK(whileI)
				i=250;						// OKM */
				break;
			default:						// ̑SĂ̏ꍇ͏Q
				i=210;						// ُM
		}
		i++;
	}
	TCCR0 = 0;								// /0~
	if (i<220)  return TEST_FAIL;
	return TEST_OK;
}

//! @brief ̊֐̖ړI/1Ƃ̊荞ݏo͂邱ƂłB
//!		   ̊֐8ޯĂ̒lԂ܂B
//! return value = TEST_OK܂TEST_FAIL
static unsigned char timer1_test(void)
{
	register unsigned char i,t,val,u;

	OCR1A = 0x5555;
	if (OCR1A != 0x5555) return TEST_FAIL;
	OCR1A = 0xAAAA;
	if (OCR1A != 0xAAAA) return TEST_FAIL;
	OCR1A = 0;

	OCR1B = 0x5555;
	if (OCR1B != 0x5555) return TEST_FAIL;
	OCR1B = 0xAAAA;
	if (OCR1B != 0xAAAA) return TEST_FAIL;
	OCR1B = 0xFF00;

	ICR1 = 0x5555;
	if (ICR1 != 0x5555) return TEST_FAIL;
	ICR1 = 0xAAAA;
	if (ICR1 != 0xAAAA) return TEST_FAIL;
	ICR1 = 0;

	TCNT1 = 0x5555;
	if (TCNT1 != 0x5555) return TEST_FAIL;
	TCNT1 = 0xAAAA;
	if (TCNT1 != 0xAAAA) return TEST_FAIL;

	TCCR1A = 0x55;
	if (TCCR1A != 0x51) return TEST_FAIL;
	TCCR1A = 0xAA;
	if (TCCR1A != 0xA2) return TEST_FAIL;
	TCCR1A = 0;

	TCCR1B = 0x55;
	if (TCCR1B != 0x55) return TEST_FAIL;
	TCCR1B = 0xAA;
	if (TCCR1B != 0x8A) return TEST_FAIL;

	/* /1荞ݐM */
	TCNT1H = 0xFF;
	TCNT1L = 100;
	OCR1AH = 0xFF;
	OCR1AL = 150;
	OCR1BH = 0xFF;
	OCR1BL = 200;
	TCCR1B = 1;								// /1~

	i=0;
	t=0;
	if ((TIFR & 0x3C)!=0) return TEST_FAIL;
	while (i < 200)							// Ԓߋ@\
	{
		val = ((TIFR>>2) & 0x0F);
		u = ((t<<4)+val);					// ԂTIFRl
		switch (u)
		{
			case 0x00:						// Ԃɗ܂
				break;
			case 0x04:						// OCF1A
				t = 4;						// 4
				break;
			case 0x44:						// 4ɗ܂
				break;
			case 0x46:						// OCF1B
				t = 6;						// 6
				break;
			case 0x66:						// 6ɗ܂
				break;
			case 0x67:						// TOV1AOK(whileI)
				i=250;						// OKM𐶐
				break;
			default:						// ̑SĂ̏ꍇ͏Q
				i=210;						// ُM𐶐
		}
		i++;
	}
	TCCR1B = 0;								// /1~
	if (i<220)  return TEST_FAIL;
	return TEST_OK;
}

//! @brief ̊֐̖ړI/2Ƃ̊荞ݏo͂邱ƂłB
//!		   ̊֐8ޯĂ̒lԂ܂B
//! return value = TEST_OK܂TEST_FAIL
static unsigned char timer2_test(void)
{
	register unsigned char i,t,val,u;

	OCR2 = 0x55;
	if (OCR2 != 0x55) return TEST_FAIL;
	OCR2 = 0xAA;
	if (OCR2 != 0xAA) return TEST_FAIL;
	OCR2 = 0;

	TCNT2 = 0x55;
	if (TCNT2 != 0x55) return TEST_FAIL;
	TCNT2 = 0xAA;
	if (TCNT2 != 0xAA) return TEST_FAIL;

	TCCR2 = 0x55;
	if (TCCR2!= 0x55) return TEST_FAIL;
	TCCR2 = 0xAA;
	if (TCCR2 != 0x2A) return TEST_FAIL;

	TCNT2 = 150;
	OCR2 = 200;
	TCCR2 = 1;								// /2n

	/* /2荞ݐM */
	i=0;
	t=0;
	if (((TIFR>>6) & 0x03)!=0) return TEST_FAIL;
	while (i < 200)							// Ԓߋ@\
	{
		val = ((TIFR>>6) & 0x03);
		u = ((t<<4)+val);					// ԂTIFRl
		switch (u)
		{
			case 0x00:						// Ԃɗ܂
				break;
			case 0x02:						// OCF2
				t = 2;						// 2
				break;
			case 0x22:						// 2ɗ܂
				break;
			case 0x23:						// TOV2AOK(whileI)
				i=250;						// OKM𐶐
				break;
			default:						// ̑SĂ̏ꍇ͏Q
				i=210;						// ُM𐶐
		}
		i++;
	}
	TCCR2 = 0;								// /2~
	if (i<220)  return TEST_FAIL;
	return TEST_OK;
}

//! @brief ̊֐̖ړI͊荞ݐ邱ƂłB
//! @pre TOV0/0ɂĊɐݒ肳Ă܂B
static unsigned char interrupt_test(void)
{
	Interrupt_Test_Flag = 0;
	TIMSK = (1<<TOIE0);						// I荞݂(Ⴆ΁A/0
	__enable_interrupt();					// S̊荞݋
	__no_operation();						// Ԃ1^
	__disable_interrupt();					// S̊荞݋֎~
	if (Interrupt_Test_Flag == 1)  return TEST_OK;
	return TEST_FAIL;
}

//! @brief ׽B̎_\n
//!		   1̎n\n
//! @return result TEST_FAIL܂TEST_OK
//!
void Startup_Test(void)
{
	char Test_Result = TEST_OK, state, loopend = 0;

	state = 0;								// Ԕԍ
	while ( (Test_Result!=TEST_FAIL) && (!loopend) )
	{
		switch ( state )
		{
			case 0:							// ޯތ
				Test_Result = watchdog_test();
				break;
			case 1:							// ð ڼ޽
				Test_Result = cpu_status_test();
				break;
			case 2:							// SRAM
				Test_Result = sram_test();
				break;
			case 3:							// /0
				Test_Result = timer0_test();
				break;
			case 4:							// /1
				Test_Result = timer1_test();
				break;
			case 5:							// /2
				Test_Result = timer2_test();
				break;
			case 6:							// 荞ݐ팟
				Test_Result = interrupt_test();
				break;
			default:
				loopend = 1;				// SI׸ސݒ
				break;
		}
		state++;							// Ԕԍis
	}
	if ( Test_Result == TEST_FAIL )
	{
		while(1);							// ׽BsȂΖJԂ
	}
}
